POJ 3126 Prime Path

来源:互联网 发布:淘宝开店ppt 编辑:程序博客网 时间:2024/06/06 01:02
Prime Path
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 16065 Accepted: 9068

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

Source

Northwestern Europe 2006


题意:给你两个数,第一个数初始值,第二个是最终值。问你第一个数经过最少多少步变化后,可以得到第二个。变化的规则是每次可以变化一个数字,然后变了后的必须为素数。

解:直接搜就可以了。来一个线性筛先把素数全部筛出来。

#include<stdio.h>#include<string.h>#include<queue>#include<algorithm>using namespace std;const int maxm=1e5+10;int vis1[maxm];int vis[maxm];int isprime[maxm];int prime[maxm];int s,e;struct node{    int x,step;};void Init(){    int cnt=0;    memset(vis1,0,sizeof(vis1));    memset(isprime,0,sizeof(isprime));    memset(prime,0,sizeof(prime));    for(int i=2; i<=maxm; i++)    {        if(!vis1[i])        {            vis1[i]=1;            prime[cnt++]=i;        }        for(int j=0; j<cnt&&i*prime[j]<=maxm; j++)        {            vis1[i*prime[j]]=1;        }    }    for(int i=0; i<cnt; i++)    {        isprime[prime[i]]=1;    }}void bfs(){    struct node pre,now;    queue<node>q;    pre.x=s;    pre.step=0;    vis[s]=1;    q.push(pre);    while(!q.empty())    {        pre=q.front();        q.pop();        if(pre.x==e)        {            printf("%d\n",pre.step);            return;        }        for(int i=1; i<=4; i++)        {            if(i==1)            {                for(int j=0; j<=9; j++)                {                    int a=(pre.x/1000);                    int b=(pre.x/100)%10;                    int c=(pre.x/10)%10;                    int d=(pre.x)%10;                    now.x=j*1000+b*100+c*10+d;                    now.step=pre.step+1;                    if(now.x>=1000&&now.x<=9999&&!vis[now.x]&&isprime[now.x])                    {                        vis[now.x]=1;                        q.push(now);                    }                }            }            if(i==2)            {                for(int j=0; j<=9; j++)                {                    int a=(pre.x/1000);                    int b=(pre.x/100)%10;                    int c=(pre.x/10)%10;                    int d=(pre.x)%10;                    now.x=a*1000+j*100+c*10+d;                    now.step=pre.step+1;                    if(now.x>=1000&&now.x<=9999&&!vis[now.x]&&isprime[now.x])                    {                        vis[now.x]=1;                        q.push(now);                    }                }            }            if(i==3)            {                for(int j=0; j<=9; j++)                {                    int a=(pre.x/1000);                    int b=(pre.x/100)%10;                    int c=(pre.x/10)%10;                    int d=(pre.x)%10;                    now.x=a*1000+b*100+j*10+d;                    now.step=pre.step+1;                    if(now.x>=1000&&now.x<=9999&&!vis[now.x]&&isprime[now.x])                    {                        vis[now.x]=1;                        q.push(now);                    }                }            }            if(i==4)            {                for(int j=0; j<=9; j++)                {                    int a=(pre.x/1000);                    int b=(pre.x/100)%10;                    int c=(pre.x/10)%10;                    int d=(pre.x)%10;                    now.x=a*1000+b*100+c*10+j;                    now.step=pre.step+1;                    if(now.x>=1000&&now.x<=9999&&!vis[now.x]&&isprime[now.x])                    {                        vis[now.x]=1;                        q.push(now);                    }                }            }        }    }    return;}int main(){    Init();    int n;    scanf("%d",&n);    while(n--)    {        memset(vis,0,sizeof(vis));        scanf("%d%d",&s,&e);        bfs();    }    return 0;}


0 0